<template>
    <div class="q-pa-md owlie" style="max-width: 400px">

    <q-form
      class="q-gutter-md"
    >
      <p class="text-h5 q-mb-none $owlieprimary;">{{$t('loginTitle')}}</p>
      <p class="text-caption q-mt-none">{{$t('messageLoginDrawer')}}</p>
      <q-input
        class="login_mail"
        filled
        v-model="mail"
        label="Email"
        lazy-rules
        :rules="[val => !!val || $t('typeMail'), isValidEmail,]"
      />
      <q-input class="login_secret" v-model="password" filled :type="isPassword ? 'password' : 'text'"
            :label="$t('password')"
            :rules="[
              val => val !== null && val !== '' ||  $t('typePassword'),
              val => val.length > 8 || $t('weakPassword')
            ]">
        <template v-slot:append>
          <q-icon
            :name="isPassword ? 'visibility_off' : 'visibility'"
            class="cursor-pointer"
            @click="isPassword = !isPassword"
          />
        </template>
      </q-input>
      <div class="row justify-center">
        <q-btn :label="$t('login')" id="login_submit"  @click="()=>dispatcher('auth/loginUser')" class="bg-secondary text-white"/>
        <q-btn :label="$t('signin')" id="login_signin" @click="()=>dispatcher('auth/createNewUser')"
          color="primary" flat class="q-ml-sm" />
      </div>
    </q-form>

  </div>
</template>

<script>

import { ref } from '@vue/composition-api';

export default {
  // name: 'ComponentName',
  setup() {
    const mail = ref('');
    const password = ref('');
    const isPassword = ref(true);
    return {
      mail,
      password,
      isPassword,
      isValidEmail(val) {
        const emailPattern = /^(?=[a-zA-Z0-9@._%+-]{6,254}$)[a-zA-Z0-9._%+-]{1,64}@(?:[a-zA-Z0-9-]{1,63}\.){1,8}[a-zA-Z]{2,63}$/;
        return emailPattern.test(val) || this.$t('wrongMail');
      },
      dispatcher(action) {
        this.$store.dispatch(action, { email: mail.value, password: password.value }).then(() => {
          this.$router.push({ path: '/todo' });
        }, (err) => this.$q.notify({ message: err.message, color: 'red' }));
      },
    };
  },
};
</script>
